/*==========================================================================*/
/* Warp3DPatch - Alain THELLIER -2011 - Paris - FRANCE 			    */
/* (If your Warp3D works perfectly then dont use this program)		    */
/* This file  patch some Warp3D bugged/unimplemented functions:		    */
/* W3D_DrawArray										    */
/* W3D_DrawElements									    */
/* W3D_DrawLine										    */
/* W3D_DrawLineStrip									    */
/* W3D_DrawLineLoop									    */
/* W3D_DrawPoint										    */
/* W3D_ReadZSpan										    */
/* W3D_WriteZSpan										    */
/* W3D_ReadZPixel										    */
/* W3D_WriteZPixel									    */
/* Use it if the hardware-driver cant draw lines/points or big lines/points */
/* Use it if the hardware-driver cant read/write in zbuffer 		    */
/* Use it if the hardware-driver cant use DrawElements/DrawArray 		    */
/*==========================================================================*/
#ifdef __amigaos4__
#define __USE_INLINE__
#define __USE_BASETYPE__
#define __USE_OLD_TIMEVAL__
#endif
/*==========================================================================*/
#include <math.h>
#include <string.h>
#include <stdarg.h>
#include <exec/types.h>
#include <exec/memory.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/graphics.h>
#include <proto/intuition.h>
#include <proto/Warp3D.h>
#include <proto/asl.h>
/*==========================================================================*/
#define ZDOUBLE	1
#define ZDOUBLEPC	2
#define ZFLOAT	3
#define ZFLOATPC	4
#define ZWORD	5
#define ZWORDPC	6
#define ZUWORD	7
#define ZUWORDPC	8
#define Z24S8	9
#define Z24S8PC	10
#define S8Z24	11
#define S8Z24PC	12
/*==========================================================================*/
struct Library *AslBase=NULL;
struct Library *Warp3DBase=NULL;
struct IntuitionBase*	IntuitionBase		=NULL;

#ifdef __amigaos4__
struct Warp3DIFace*			IWarp3D		=NULL;
struct IntuitionIFace*			IIntuition		=NULL;
struct AslIFace*				IAsl 				=NULL;
#endif
/*==========================================================================*/
APTR PtrW3D_DrawArray;
APTR PtrW3D_DrawElements;
APTR PtrW3D_DrawLine;
APTR PtrW3D_DrawLineStrip;
APTR PtrW3D_DrawLineLoop;
APTR PtrW3D_DrawPoint;
APTR PtrW3D_ReadZSpan;
APTR PtrW3D_WriteZSpan;
APTR PtrW3D_ReadZPixel;
APTR PtrW3D_WriteZPixel;
/*==========================================================================*/
#define NLOOP(nbre) for(n=0;n<nbre;n++)
#define ILOOP(nbre) for(i=0;i<nbre;i++)
#define COPYRGBA(x,y)	*((ULONG *)(x))=*((ULONG *)(y));
#define W3D_INDEX_NONE 9999
#define VAR(var)   printf(" " #var "=" ); printf("%ld\n",  ((ULONG)var)  );
#define AND &
/*==========================================================================*/
/* this define a disc shape to draw the big points */
float discx[36]={0.5000,0.4924,0.4698,0.4330,0.3830,0.3214,0.2500,0.1710,0.0868,0.0000,-0.0868,-0.1710,-0.2500,-0.3214,-0.3830,-0.4330,-0.4698,-0.4924,-0.5000,-0.4924,-0.4698,-0.4330,-0.3830,-0.3214,-0.2500,-0.1710,-0.0868,0.0000,0.0868,0.1710,0.2500,0.3214,0.3830,0.4330,0.4698,0.4924};
float discy[36]={0.0000,0.0868,0.1710,0.2500,0.3214,0.3830,0.4330,0.4698,0.4924,0.5000,0.4924,0.4698,0.4330,0.3830,0.3214,0.2500,0.1710,0.0868,0.0000,-0.0868,-0.1710,-0.2500,-0.3214,-0.3830,-0.4330,-0.4698,-0.4924,-0.5000,-0.4924,-0.4698,-0.4330,-0.3830,-0.3214,-0.2500,-0.1710,-0.0868};
static ULONG zsizes[13]={0,64,64,32,32,16,16,16,16,32,32,32,32};
static LONG zformat=0;
/*======================================================================================*/
#ifdef __amigaos4__
;
#else
/*  Name:			SDI_compiler.h
	Versionstring:	$VER: SDI_compiler.h 1.4 (30.03.2000)
	Author:		SDI
	Distribution:	PD
	Description:	defines to hide compiler stuff

 1.1   25.06.98 : created from data made by Gunter Nikl
 1.2   17.11.99 : added VBCC
 1.3   29.02.00 : fixed VBCC REG define
 1.4   30.03.00 : fixed SAVEDS for VBCC
*/
/*======================================================================================*/
/* first "exceptions" */

#if defined(__MAXON__)
  #define STDARGS
  #define REGARGS
  #define SAVEDS
  #define INLINE inline
#elif defined(__VBCC__)
  #define STDARGS
  #define REGARGS
  #define INLINE
  #define REG(reg,arg) __reg(#reg) arg
#elif defined(__STORM__)
  #define STDARGS
  #define REGARGS
  #define INLINE inline
#elif defined(__SASC)
  #define ASM(arg) arg __asm
#elif defined(__GNUC__)
  #define REG(reg,arg) arg __asm(#reg)
  #define LREG(reg,arg) register REG(reg,arg)
#endif

/* then "common" ones */

#if !defined(ASM)
  #define ASM(arg) arg
#endif
#if !defined(REG)
  #define REG(reg,arg) register __##reg arg
#endif
#if !defined(LREG)
  #define LREG(reg,arg) register arg
#endif
#if !defined(CONST)
  #define CONST const
#endif
#if !defined(SAVEDS)
  #define SAVEDS __saveds
#endif
#if !defined(INLINE)
  #define INLINE __inline
#endif
#if !defined(REGARGS)
  #define REGARGS __regargs
#endif
#if !defined(STDARGS)
  #define STDARGS __stdargs
#endif

#define D0(arg)  REG(d0,arg)
#define D1(arg)  REG(d1,arg)
#define D2(arg)  REG(d2,arg)
#define D3(arg)  REG(d3,arg)
#define D4(arg)  REG(d4,arg)
#define D5(arg)  REG(d5,arg)
#define D6(arg)  REG(d6,arg)
#define D7(arg)  REG(d7,arg)

#define A0(arg)  REG(a0,arg)
#define A1(arg)  REG(a1,arg)
#define A2(arg)  REG(a2,arg)
#define A3(arg)  REG(a3,arg)
#define A4(arg)  REG(a4,arg)
#define A5(arg)  REG(a5,arg)
#define A6(arg)  REG(a6,arg)
#define A7(arg)  REG(a7,arg)
#endif
/*==========================================================================*/
struct drawcontext{
	W3D_Context *context;
	ULONG primitive;
	ULONG type;
	ULONG count;
	void *indices;
	ULONG base;
};
/*==================================================================================*/
struct point3D{
	float x,y,z;
	float u,v;
	float w;
	UBYTE RGBA[4];
};
/*==========================================================================*/
struct VertexFFF{
	float x,y,z;
};
/*==========================================================================*/
struct VertexFFD{
	float x,y;
	double z;
};
/*==========================================================================*/
struct VertexDDD{
	double x,y,z;
};
/*==================================================================================*/
void OSAlert(void *p1)
{
UBYTE *t=p1;
void *Data=&t+1L;
struct EasyStruct EasyStruct;
ULONG IDCMPFlags;

	EasyStruct.es_StructSize=sizeof(struct EasyStruct);
	EasyStruct.es_Flags=0L;
	EasyStruct.es_Title=(void *)"Message:";
	EasyStruct.es_TextFormat=(void*)t;
	EasyStruct.es_GadgetFormat=(void*)"OK";

	IDCMPFlags=0L;
	(void)EasyRequestArgs(NULL,&EasyStruct,&IDCMPFlags,Data);
	return;
}
/*==========================================================================*/
void ColorToRGBA(UBYTE *RGBA,float r,float g,float b,float a)
{
	RGBA[0]=(UBYTE)(r*256.0);
	if(1.0<=r)	RGBA[0]=255;
	if(r<=0.0)	RGBA[0]=0;
	RGBA[1]=(UBYTE)(g*256.0);
	if(1.0<=g)	RGBA[1]=255;
	if(g<=0.0)	RGBA[1]=0;
	RGBA[2]=(UBYTE)(b*256.0);
	if(1.0<=b)	RGBA[2]=255;
	if(b<=0.0)	RGBA[2]=0;
	RGBA[3]=(UBYTE)(a*256.0);
	if(1.0<=a)	RGBA[3]=255;
	if(a<=0.0)	RGBA[3]=0;
}
/*==========================================================================*/
void GetPoint(W3D_Context *context,struct point3D *P,ULONG i)
{
UBYTE *V		=context->VertexPointer;
ULONG  Vformat	=context->VPMode;
ULONG  Vstride	=context->VPStride;

WORD   unit		=0;	/* default use tex0 TODO: manage multi texturing */
W3D_Texture *texture=context->CurrentTex[unit];
UBYTE *UV		=context->TexCoordPointer[unit];
ULONG  UVformat	=context->TPFlags[unit];
ULONG  UVstride	=context->TPStride[unit];
ULONG  UVoffsetv	=context->TPVOffs[unit];
ULONG  UVoffsetw	=context->TPWOffs[unit];

UBYTE *C		=context->ColorPointer;
ULONG  Cformat	=context->CPMode;
ULONG  Cstride	=context->CPStride;

UBYTE *pt;
struct VertexFFF *fff;
struct VertexFFD *ffd;
struct VertexDDD *ddd;
float *u;
float *v;
float *w;
float *rgbaF;
UBYTE *rgbaB;
UBYTE  RGBA[4];


	P->x=P->y=P->z=P->u=P->v=0.0;
	P->RGBA[0]=P->RGBA[1]=P->RGBA[2]=P->RGBA[3]=255; 	/* default: use white. TODO: use CurrentColor */


/* recover XYZ values */
	if(V!=NULL)
	{
	pt=&(V[i*Vstride]);

	if(Vformat==W3D_VERTEX_F_F_F)
	{
	fff=(struct VertexFFF *)pt;
	P->x=fff->x;
	P->y=fff->y;
	P->z=fff->z;
	}

	if(Vformat==W3D_VERTEX_F_F_D)
	{
	ffd=(struct VertexFFD *)pt;
	P->x=ffd->x;
	P->y=ffd->y;
	P->z=(float)ffd->z;
	}

	if(Vformat==W3D_VERTEX_D_D_D)
	{
	ddd=(struct VertexDDD *)pt;
	P->x=(float)ddd->x;
	P->y=(float)ddd->y;
	P->z=(float)ddd->z;
	}

	P->w=1.0/P->z;
	}


/* recover UV values */
	if(V!=NULL)
	{
	pt=&(UV[i*UVstride]);
	u=(float *)pt;
	v=(float *)&pt[UVoffsetv];
	w=(float *)&pt[UVoffsetw];

	if(UVformat==W3D_TEXCOORD_NORMALIZED)
	{
	P->u=u[0] ;
	P->v=v[0] ;
	P->w=w[0] ;
	}
	else
	{
	P->u=u[0] /texture->texwidth;
	P->v=v[0] /texture->texheight;
	P->w=w[0] ;
	}
	}

/* recover Color RGBA values */
	if(C!=NULL)
	{
	pt=&(C[i*Cstride]);
	if(Cformat AND W3D_COLOR_FLOAT)
		{
		rgbaF=(float *)pt;
		ColorToRGBA(RGBA,rgbaF[0],rgbaF[1],rgbaF[2],rgbaF[3]);
		}
	if(Cformat AND W3D_COLOR_UBYTE)
		{
		rgbaB=(UBYTE *)pt;
		COPYRGBA(RGBA,rgbaB);
		}
	if(Cformat AND W3D_CMODE_RGB)
		{P->RGBA[0]=RGBA[0]; P->RGBA[1]=RGBA[1]; P->RGBA[2]=RGBA[2]; P->RGBA[3]=255;		}
	if(Cformat AND W3D_CMODE_BGR)
		{P->RGBA[0]=RGBA[2]; P->RGBA[1]=RGBA[1]; P->RGBA[2]=RGBA[0]; P->RGBA[3]=255;		}
	if(Cformat AND W3D_CMODE_RGBA)
		{P->RGBA[0]=RGBA[0]; P->RGBA[1]=RGBA[1]; P->RGBA[2]=RGBA[2]; P->RGBA[3]=RGBA[3];	}
	if(Cformat AND W3D_CMODE_ARGB)
		{P->RGBA[0]=RGBA[1]; P->RGBA[1]=RGBA[2]; P->RGBA[2]=RGBA[3]; P->RGBA[3]=RGBA[0];	}
	if(Cformat AND W3D_CMODE_BGRA)
		{P->RGBA[0]=RGBA[2]; P->RGBA[1]=RGBA[1]; P->RGBA[2]=RGBA[0]; P->RGBA[3]=RGBA[3];	}
	}

}
/*==================================================================*/
void PtoV(W3D_Context *context,struct point3D *P,W3D_Vertex *v)
{
WORD   unit		=0;	/* default use tex0 TODO: manage multi texturing */
W3D_Texture *texture=context->CurrentTex[unit];

	v->x=P->x; v->y=P->y; v->z=P->z; v->w=P->w;
	v->u=P->u*texture->texwidth; v->v=P->v*texture->texheight;
	v->color.r=(float)P->RGBA[0]/255.0;
	v->color.g=(float)P->RGBA[1]/255.0;
	v->color.b=(float)P->RGBA[2]/255.0;
	v->color.a=(float)P->RGBA[3]/255.0;
}
/*==================================================================*/
void DrawTri(struct drawcontext *C,ULONG a,ULONG b,ULONG c)
{
W3D_Context *context=C->context;
WORD   unit		=0;	/* default use tex0 TODO: manage multi texturing */
W3D_Texture *texture=context->CurrentTex[unit];
W3D_Triangle tri;
W3D_Vertex *v;
UBYTE *I8 =C->indices;
UWORD *I16=C->indices;
ULONG *I32=C->indices;
struct point3D  PA;
struct point3D  PB;
struct point3D  PC;

	if(C->type==W3D_INDEX_NONE)
		{ a=a+C->base; b=b+C->base; c=c+C->base; }

	if(C->type==W3D_INDEX_UBYTE)
		{ a=I8[a];  b=I8[b];  c=I8[c];  }

	if(C->type==W3D_INDEX_UWORD)
		{ a=I16[a]; b=I16[b]; c=I16[c]; }

	if(C->type==W3D_INDEX_ULONG)
		{ a=I32[a]; b=I32[b]; c=I32[c]; }

	GetPoint(context,&PA,a);
	GetPoint(context,&PB,b);
	GetPoint(context,&PC,c);

	PtoV(context,&PA,&tri.v1);
	PtoV(context,&PB,&tri.v2);
	PtoV(context,&PC,&tri.v3);

	tri.tex=texture;

 	W3D_DrawTriangle(context, &tri);
}
/*================================================================*/
void DrawPrimitive(struct drawcontext *C)
{
ULONG n;
ULONG primitive=C->primitive;
ULONG nb=C->count;

	if(primitive==W3D_PRIMITIVE_TRIANGLES)
	{
	nb=nb/3;
	NLOOP(nb)
		DrawTri(C,3*n+0,3*n+1,3*n+2);
	}

	if(primitive==W3D_PRIMITIVE_TRIFAN)
	{
	for (n=2;n<nb;n++)
		DrawTri(C,0,n-1,n);
	return;
	}

	if(primitive==W3D_PRIMITIVE_TRISTRIP)
	{
	for (n=2;n<nb;n++)
	if (n&1)	  /* reverse vertex order */
		DrawTri(C,n-1,n-2,n-0);
	else
		DrawTri(C,n-2,n-1,n-0);
	return;
	}

	if(primitive==W3D_PRIMITIVE_POINTS)
	{
	NLOOP(nb)
		{
		DrawTri(C,n,n,n);
		}
	}

	if(primitive==W3D_PRIMITIVE_LINES)
	{
	nb=nb/2;
	NLOOP(nb)
		{
		DrawTri(C,2*n,2*n+1,2*n+1);
		}
	return;
	}

	if(primitive==W3D_PRIMITIVE_LINELOOP)
	{
	nb=nb-1;
	NLOOP(nb)
		{
		DrawTri(C,n,n+1,n+1);
		}

	DrawTri(C,nb,0,0);
	return;
	}

	if(primitive==W3D_PRIMITIVE_LINESTRIP)
	{
	nb=nb-1;
	NLOOP(nb)
		{
		DrawTri(C,n,n+1,n+1);
		}
	return;
	}
}
/*==========================================================================*/
ULONG PatchW3D_DrawArray(W3D_Context* context, ULONG primitive, ULONG base, ULONG count)
{
struct drawcontext C;

	C.context	=context;
	C.primitive	=primitive;
	C.type	=W3D_INDEX_NONE;
	C.count	=count;
	C.indices	=NULL;
	C.base	=base;

	DrawPrimitive(&C);
	return(W3D_SUCCESS);
}
/*==========================================================================*/
ULONG PatchW3D_DrawElements(W3D_Context* context, ULONG primitive, ULONG type, ULONG count,void *indices)
{
struct drawcontext C;

	C.context	=context;
	C.primitive	=primitive;
	C.type	=type;
	C.count	=count;
	C.indices	=indices;
	C.base	=0;

	DrawPrimitive(&C);
	return(W3D_SUCCESS);
}
/*==========================================================================*/
ULONG DrawLine(W3D_Context *context,W3D_Vertex *v1,W3D_Vertex *v2,W3D_Texture *tex,float size)
{
/* draw a line as a quad with variable size */
W3D_Vertex quad[4];
W3D_Triangles triangles;
register ULONG result;
float dim,x,y;
ULONG currentstate;


	if(size<1.0) size=1.0;
	currentstate=W3D_GetState(context,W3D_CULLFACE);
	W3D_SetState(context,W3D_CULLFACE,W3D_DISABLE);		/* a line is never an hidden-face */
	triangles.v 		=quad;
	triangles.tex		=tex;
	triangles.vertexcount	=4;
	memcpy(&quad[0],v1,sizeof(W3D_Vertex));
	memcpy(&quad[1],v2,sizeof(W3D_Vertex));
	memcpy(&quad[2],v2,sizeof(W3D_Vertex));
	memcpy(&quad[3],v1,sizeof(W3D_Vertex));
	x=(v2->x - v1->x);
	y=(v2->y - v1->y);
	dim=sqrt( x*x + y*y );

	if(dim!=0.0)
	{
	size=size/(dim*2.0);
	x=size*x;
	y=size*y;
	quad[0].x += y; 	quad[0].y -= x;
 	quad[1].x += y; 	quad[1].y -= x;
	quad[2].x -= y;	quad[2].y += x;
	quad[3].x -= y;	quad[3].y += x;
	}
	else
	{
	quad[0].x += 0.0; 	quad[0].y += 0.0;
 	quad[1].x += size; 	quad[1].y += 0.0;
 	quad[2].x += size; 	quad[2].y += size;
 	quad[3].x += 0.0; 	quad[3].y += size;
	}

	result=W3D_DrawTriFan(context,&triangles);
	W3D_SetState(context,W3D_CULLFACE,currentstate);
	return(result);
}
/*==========================================================================*/
ULONG DrawDisc(W3D_Context *context,W3D_Vertex *v1,W3D_Texture *tex,float size)
{
/* draw a disc as a trifan with variable size */
W3D_Vertex disc[36];
W3D_Triangles triangles;
register W3D_Vertex *v=disc;
register ULONG result;
register ULONG n;
ULONG currentstate;

	currentstate=W3D_GetState(context,W3D_CULLFACE);
	W3D_SetState(context,W3D_CULLFACE,W3D_DISABLE);		/* a point is never an hidden-face */
	triangles.v 		=v;
	triangles.tex		=tex;
	triangles.vertexcount	=36;
	NLOOP(36)
		{
		memcpy(v,v1,sizeof(W3D_Vertex));
		v->x += discx[n]*size;
		v->y += discy[n]*size;
		v++;
		}
	result=W3D_DrawTriFan(context,&triangles);
	W3D_SetState(context,W3D_CULLFACE,currentstate);
	return(result);
}
/*==========================================================================*/
ULONG PatchW3D_DrawLine(W3D_Context *context, W3D_Line *line)
{
/* draw a single line */
register ULONG result;

	result=DrawLine(context,&line->v1,&line->v2,line->tex,line->linewidth);
	return(result);
}
/*==========================================================================*/
ULONG PatchW3D_DrawLineStrip(W3D_Context *context, W3D_Lines *lines)
{
register W3D_Vertex *v	=lines->v;
register LONG nlines	=lines->vertexcount-1;
register ULONG result	=W3D_SUCCESS;
register LONG n;

NLOOP(nlines)
	{
	result=DrawLine(context,&v[0],&v[1],lines->tex,lines->linewidth);
	v++;
	}
	return(result);
}
/*==========================================================================*/
ULONG PatchW3D_DrawLineLoop(W3D_Context *context, W3D_Lines *lines)
{
register W3D_Vertex *v	=lines->v;
register LONG nlines	=lines->vertexcount-1;
register ULONG result;
register LONG n;

NLOOP(nlines)
	{
	result=DrawLine(context,&v[0],&v[1],lines->tex,lines->linewidth);
	v++;
	}
	result=DrawLine(context,&v[0],lines->v,lines->tex,lines->linewidth);
	return(result);
}
/*==========================================================================*/
ULONG PatchW3D_DrawPoint(W3D_Context *context, W3D_Point *point)
{
register ULONG result;

	if(point->pointsize>=3.0)
		result=DrawDisc(context,&point->v1,point->tex,point->pointsize);
	else
		result=DrawLine(context,&point->v1,&point->v1,point->tex,point->pointsize);

	return(result);
}
/*==========================================================================*/
void findzformat(W3D_Context *context)
{
#define TESTZ 0.1
W3D_Double dz=TESTZ;
ULONG n;

	zformat=-1;
	if(W3D_ClearZBuffer(context,&dz)!=W3D_SUCCESS)	/* put a given value in zbuffer */
		{printf("no zbuffer so cant find z format\n");return;}
	NLOOP(12)
		{
		zformat=n+1; 						/* try all z formats */
		W3D_ReadZPixel(context,0,0,&dz);		/* try to re-read the zbuffer with this format */
		if((TESTZ-0.001) < dz )					/* is it aproximately the same value  ? */
		if(dz < (TESTZ+0.001) )
			{printf("found z format %ld\n",zformat); return;}
		}
	zformat=-1;
	printf("cant find z format\n");
}
/*==========================================================================*/
ULONG PatchW3D_ReadZSpan(W3D_Context *context, ULONG x, ULONG y,ULONG n, W3D_Double *z)
{
register UBYTE *zbuffer;
register ULONG i;
register float  *fz;
register double *dz;
register  WORD  *wz;
register UWORD  *uwz;
register ULONG  *ulz;
UBYTE t[8];
ULONG zsize;
ULONG result;

	if(context->zbuffer==NULL) return(W3D_NOZBUFFER);

	if(zformat== 0) findzformat(context);
	if(zformat==-1) return(W3D_NOZBUFFER);
	result=W3D_SUCCESS;
	zsize=zsizes[zformat]/8;

	zbuffer=context->zbuffer+((y*context->width+x)*zsize);	/* offset from start */

	if(zformat==ZFLOAT)
	ILOOP(n)
		{
		fz=(float*)zbuffer;
		z[i]=(double)fz[0]; zbuffer+=zsize;
		}

	if(zformat==ZFLOATPC)
	ILOOP(n)
		{
		fz=(float*)t;
		t[3]=zbuffer[0]; t[2]=zbuffer[1]; t[1]=zbuffer[2]; t[0]=zbuffer[3];
		z[i]=(double)fz[0]; zbuffer+=zsize;
		}

	if(zformat==ZDOUBLE)
	ILOOP(n)
		{
		dz=(double*)zbuffer;
		z[i]=(double)dz[0]; zbuffer+=zsize;
		}

	if(zformat==ZDOUBLEPC)
	ILOOP(n)
		{
		dz=(double*)t;
		t[7]=zbuffer[0]; t[6]=zbuffer[1]; t[5]=zbuffer[2]; t[4]=zbuffer[3]; t[3]=zbuffer[4]; t[2]=zbuffer[5]; t[1]=zbuffer[6]; t[0]=zbuffer[7];
		z[i]=dz[0]; zbuffer+=zsize;
		}

	if(zformat==ZWORD)
	ILOOP(n)
		{
		wz=(WORD*)zbuffer;
		z[i]=((double)wz[0])/32767.0; zbuffer+=zsize;
		}

	if(zformat==ZWORDPC)
	ILOOP(n)
		{
		wz=(WORD*)t;
		t[1]=zbuffer[0]; t[0]=zbuffer[1];
		z[i]=((double)wz[0])/32767.0; zbuffer+=zsize;
		}

	if(zformat==ZUWORD)
	ILOOP(n)
		{
		uwz=(UWORD*)zbuffer;
		z[i]=((double)uwz[0])/65535.0;  zbuffer+=zsize;
		}

	if(zformat==ZUWORDPC)
	ILOOP(n)
		{
		uwz=(UWORD*)t;
		t[1]=zbuffer[0]; t[0]=zbuffer[1];
		z[i]=((double)uwz[0])/65535.0; zbuffer+=zsize;
		}

	if(zformat==Z24S8)
	ILOOP(n)
		{
		ulz=(ULONG*)t;
		t[0]=0; t[1]=zbuffer[0]; t[2]=zbuffer[1]; t[3]=zbuffer[2];
		z[i]=((double)ulz[0])/16777215.0; zbuffer+=zsize;
		}

	if(zformat==Z24S8PC)
	ILOOP(n)
		{
		ulz=(ULONG*)t;
		t[0]=0; t[1]=zbuffer[3]; t[2]=zbuffer[2]; t[3]=zbuffer[1];
		z[i]=((double)ulz[0])/16777215.0; zbuffer+=zsize;
		}

	if(zformat==S8Z24)
	ILOOP(n)
		{
		ulz=(ULONG*)t;
		t[0]=0; t[1]=zbuffer[1]; t[2]=zbuffer[2]; t[3]=zbuffer[3];
		z[i]=((double)ulz[0])/16777215.0; zbuffer+=zsize;
		}

	if(zformat==S8Z24PC)
	ILOOP(n)
		{
		ulz=(ULONG*)t;
		t[0]=0; t[1]=zbuffer[0]; t[2]=zbuffer[1]; t[3]=zbuffer[2];
		z[i]=((double)ulz[0])/16777215.0; zbuffer+=zsize;
		}

	return(result);
}
/*==========================================================================*/
void PatchW3D_WriteZSpan(W3D_Context *context, ULONG x, ULONG y,ULONG n, W3D_Double *z, UBYTE *mask)
{
register UBYTE *zbuffer;
register UBYTE *m=mask;
register ULONG i;
UBYTE t[8];
register float  *fz;
register double *dz;
register  WORD  *wz;
register UWORD  *uwz;
register ULONG  *ulz;
UBYTE *z8;
ULONG zsize;

	if(context->zbuffer==NULL) return;

	if(zformat==0) findzformat(context);
	if(zformat==-1)
	{
	z8=context->zbuffer;
	printf("Unknown zformat! Zbuffer contain [%d %d %d %d] [%d %d %d %d]...\n",z8[0],z8[1],z8[2],z8[3],z8[4],z8[5],z8[6],z8[7]);
	return;
	}
	zsize=zsizes[zformat]/8;

	zbuffer=context->zbuffer+((y*context->width+x)*zsize);	/* offset from start */

	if(zformat==ZFLOAT)
	ILOOP(n)
		{
		if(m[i]!=0)
			{
			fz=(float*)zbuffer;
			fz[0]=(float)z[i];
			}
		zbuffer+=zsize;
		}

	if(zformat==ZFLOATPC)
	ILOOP(n)
		{
		if(m[i]!=0)
			{
			fz=(float*)t;
			fz[0]=(float)z[i];
			zbuffer[3]=t[0]; zbuffer[2]=t[1]; zbuffer[1]=t[2]; zbuffer[0]=t[3];
	 		}
		zbuffer+=zsize;
		}

	if(zformat==ZDOUBLE)
	ILOOP(n)
		{
		if(m[i]!=0)
			{
			dz=(double*)zbuffer;
			dz[0]=(double)z[i];
			}
		zbuffer+=zsize;
		}

	if(zformat==ZDOUBLEPC)
	ILOOP(n)
		{
		if(m[i]!=0)
			{
			dz=(double*)t;
			dz[0]=(double)z[i];
			zbuffer[7]=t[0]; zbuffer[6]=t[1]; zbuffer[5]=t[2]; zbuffer[4]=t[3];zbuffer[3]=t[4]; zbuffer[2]=t[5]; zbuffer[1]=t[6]; zbuffer[0]=t[7];
	 		}
		zbuffer+=zsize;
		}

	if(zformat==ZWORD)
	ILOOP(n)
		{
		if(m[i]!=0)
			{
			wz=(WORD*)zbuffer;
			wz[0]=(WORD)(z[i]*32767.0);
			}
		zbuffer+=zsize;
		}

	if(zformat==ZWORDPC)
	ILOOP(n)
		{
		if(m[i]!=0)
			{
			wz=(WORD*)t;
			wz[0]=(WORD)(z[i]*32767.0);
			zbuffer[1]=t[0]; zbuffer[0]=t[1];
	 		}
		zbuffer+=zsize;
		}

	if(zformat==ZUWORD)
	ILOOP(n)
		{
		if(m[i]!=0)
			{
			uwz=(UWORD*)zbuffer;
			uwz[0]=(UWORD)(z[i]*65535.0);
			}
		zbuffer+=zsize;
		}

	if(zformat==ZUWORDPC)
	ILOOP(n)
		{
		if(m[i]!=0)
			{
			uwz=(UWORD*)t;
			uwz[0]=(UWORD)(z[i]*65535.0);
			zbuffer[1]=t[0]; zbuffer[0]=t[1];
	 		}
		zbuffer+=zsize;
		}

	if(zformat==Z24S8)
	ILOOP(n)
		{
		if(m[i]!=0)
			{
			ulz=(ULONG*)t;
			ulz[0]=(ULONG)(z[i]*16777215.0);
			zbuffer[0]=t[1]; zbuffer[1]=t[2]; zbuffer[2]=t[3];
	 		}
		zbuffer+=zsize;
		}

	if(zformat==Z24S8PC)
	ILOOP(n)
		{
		if(m[i]!=0)
			{
			ulz=(ULONG*)t;
			ulz[0]=(ULONG)(z[i]*16777215.0);
			zbuffer[3]=t[1]; zbuffer[2]=t[2]; zbuffer[1]=t[3];
	 		}
		zbuffer+=zsize;
		}

	if(zformat==S8Z24)
	ILOOP(n)
		{
		if(m[i]!=0)
			{
			ulz=(ULONG*)t;
			ulz[0]=(ULONG)(z[i]*16777215.0);
			zbuffer[1]=t[1]; zbuffer[2]=t[2]; zbuffer[3]=t[3];
		 	}
		zbuffer+=zsize;
		}

	if(zformat==S8Z24PC)
	ILOOP(n)
		{
		if(m[i]!=0)
			{
			ulz=(ULONG*)t;
			ulz[0]=(ULONG)(z[i]*16777215.0);
			zbuffer[0]=t[1]; zbuffer[1]=t[2]; zbuffer[2]=t[3];
	 		}
		zbuffer+=zsize;
		}

}
/*==========================================================================*/
ULONG PatchW3D_ReadZPixel(W3D_Context *context, ULONG x, ULONG y,W3D_Double *dz)
{
	return(W3D_ReadZSpan(context,x,y,1,dz));
}
/*==========================================================================*/
void PatchW3D_WriteZPixel(W3D_Context *context, ULONG x, ULONG y,W3D_Double *dz)
{
UBYTE mask=1;

	W3D_WriteZSpan(context,x,y,1,dz,&mask);
}
/*==========================================================================*/
#ifdef __amigaos4__
/* glue functions = C to C with *Self */
ULONG LibW3D_DrawPoint       (void *Self,W3D_Context* context,W3D_Point* point) {return PatchW3D_DrawPoint(context,point);}
ULONG LibW3D_DrawLine        (void *Self,W3D_Context* context,W3D_Line* line) {return PatchW3D_DrawLine(context,line);}
ULONG LibW3D_DrawLineStrip   (void *Self,W3D_Context* context,W3D_Lines* lines) {return PatchW3D_DrawLineStrip(context,lines);}
ULONG LibW3D_DrawLineLoop    (void *Self,W3D_Context* context,W3D_Lines* lines) {return PatchW3D_DrawLineLoop(context,lines);}
ULONG LibW3D_ReadZPixel      (void *Self,W3D_Context* context,ULONG x,ULONG y,W3D_Double* z) {return PatchW3D_ReadZPixel(context,x,y,z);}
ULONG LibW3D_ReadZSpan       (void *Self,W3D_Context* context,ULONG x,ULONG y,ULONG n,W3D_Double* z) {return PatchW3D_ReadZSpan(context,x,y,n,z);}
void  LibW3D_WriteZPixel     (void *Self,W3D_Context* context,ULONG x,ULONG y,W3D_Double* z) {W3D_WriteZPixel(context,x,y,z);}
void  LibW3D_WriteZSpan      (void *Self,W3D_Context* context,ULONG x,ULONG y,ULONG n,W3D_Double* z,UBYTE* mask) {W3D_WriteZSpan(context,x,y,n,z,mask);}
ULONG LibW3D_DrawArray	    (void *Self,W3D_Context* context,ULONG primitive,ULONG base,ULONG count) {return PatchW3D_DrawArray(context,primitive,base,count);}
ULONG LibW3D_DrawElements    (void *Self,W3D_Context* context,ULONG primitive,ULONG type,ULONG count,void* indices) {return PatchW3D_DrawElements(context,primitive,type,count,indices);}
/*==========================================================================*/
#else
/* glue functions = ASM to C */
ASM(ULONG) LibW3D_DrawPoint       (A0(W3D_Context* context), A1(W3D_Point* point)) {return PatchW3D_DrawPoint(context,point);}
ASM(ULONG) LibW3D_DrawLine        (A0(W3D_Context* context), A1(W3D_Line* line)) {return PatchW3D_DrawLine(context,line);}
ASM(ULONG) LibW3D_DrawLineStrip   (A0(W3D_Context* context), A1(W3D_Lines* lines)) {return PatchW3D_DrawLineStrip(context,lines);}
ASM(ULONG) LibW3D_DrawLineLoop    (A0(W3D_Context* context), A1(W3D_Lines* lines)) {return PatchW3D_DrawLineLoop(context,lines);}
ASM(ULONG) LibW3D_ReadZPixel      (A0(W3D_Context* context), D0(ULONG x), D1(ULONG y), A1(W3D_Double* z)) {return PatchW3D_ReadZPixel(context,x,y,z);}
ASM(ULONG) LibW3D_ReadZSpan       (A0(W3D_Context* context), D0(ULONG x), D1(ULONG y), D2(ULONG n), A1(W3D_Double* z)) {return PatchW3D_ReadZSpan(context,x,y,n,z);}
ASM(void ) LibW3D_WriteZPixel     (A0(W3D_Context* context), D0(ULONG x), D1(ULONG y), A1(W3D_Double* z)) {W3D_WriteZPixel(context,x,y,z);}
ASM(void ) LibW3D_WriteZSpan      (A0(W3D_Context* context), D0(ULONG x), D1(ULONG y), D2(ULONG n), A1(W3D_Double* z), A2(UBYTE* mask)) {W3D_WriteZSpan(context,x,y,n,z,mask);}
ASM(ULONG) LibW3D_DrawArray	    (A0(W3D_Context* context), D0(ULONG primitive), D1(ULONG base), D2(ULONG count)) {return PatchW3D_DrawArray(context,primitive,base,count);}
ASM(ULONG) LibW3D_DrawElements    (A0(W3D_Context* context), D0(ULONG primitive), D1(ULONG type), D2(ULONG count), A1(void* indices)) {return PatchW3D_DrawElements(context,primitive,type,count,indices);}
#endif
/*==========================================================================*/
int main(int argc, char **argv)
{

	IntuitionBase=(void*)OpenLibrary("intuition.library", 0L);
	AslBase 	=(void*)OpenLibrary("asl.library", 37L);
	Warp3DBase	=(void*)OpenLibrary("Warp3D.library", 4L);
	if (Warp3DBase==NULL)	exit(0);

#ifdef __amigaos4__
	IIntuition	= (struct IntuitionIFace*)GetInterface((struct Library *)IntuitionBase, "main", 1, NULL);
	IAsl 		= (struct AslIFace*)GetInterface((struct Library *)AslBase, "main", 1, NULL);
	IWarp3D 	= (struct Warp3DIFace*)GetInterface((struct Library *)Warp3DBase, "main", 1, NULL);
	if (IWarp3D==NULL)	return(FALSE);
#endif

#ifdef __amigaos4__
	PtrW3D_DrawPoint		=SetMethod(IWarp3D, offsetof(struct Warp3DIFace, W3D_DrawPoint)	 ,(APTR)LibW3D_DrawPoint); 
	PtrW3D_DrawLine		=SetMethod(IWarp3D, offsetof(struct Warp3DIFace, W3D_DrawLine)	 ,(APTR)LibW3D_DrawLine); 
	PtrW3D_DrawLineStrip	=SetMethod(IWarp3D, offsetof(struct Warp3DIFace, W3D_DrawLineStrip),(APTR)LibW3D_DrawLineStrip); 
	PtrW3D_DrawLineLoop	=SetMethod(IWarp3D, offsetof(struct Warp3DIFace, W3D_DrawLineLoop) ,(APTR)LibW3D_DrawLineLoop); 

	PtrW3D_ReadZPixel	=SetMethod(IWarp3D, offsetof(struct Warp3DIFace, W3D_ReadZPixel)	,(APTR)LibW3D_ReadZPixel); 
	PtrW3D_ReadZSpan		=SetMethod(IWarp3D, offsetof(struct Warp3DIFace, W3D_ReadZSpan)	,(APTR)LibW3D_ReadZSpan); 
	PtrW3D_WriteZPixel	=SetMethod(IWarp3D, offsetof(struct Warp3DIFace, W3D_WriteZPixel)	,(APTR)LibW3D_WriteZPixel); 
	PtrW3D_WriteZSpan	=SetMethod(IWarp3D, offsetof(struct Warp3DIFace, W3D_WriteZSpan)	,(APTR)LibW3D_WriteZSpan); 

	PtrW3D_DrawArray		=SetMethod(IWarp3D, offsetof(struct Warp3DIFace, W3D_DrawArray)	,(APTR)LibW3D_DrawArray); 
	PtrW3D_DrawElements	=SetMethod(IWarp3D, offsetof(struct Warp3DIFace, W3D_DrawElements),(APTR)LibW3D_DrawElements); 

#else
	PtrW3D_DrawPoint		=SetFunction((struct Library *)Warp3DBase,-156,(APTR)LibW3D_DrawPoint);
	PtrW3D_DrawLine		=SetFunction((struct Library *)Warp3DBase,-150,(APTR)LibW3D_DrawLine);
	PtrW3D_DrawLineStrip	=SetFunction((struct Library *)Warp3DBase,-390,(APTR)LibW3D_DrawLineStrip);
	PtrW3D_DrawLineLoop	=SetFunction((struct Library *)Warp3DBase,-396,(APTR)LibW3D_DrawLineLoop);

	PtrW3D_ReadZPixel		=SetFunction((struct Library *)Warp3DBase,-234,(APTR)LibW3D_ReadZPixel);
	PtrW3D_ReadZSpan		=SetFunction((struct Library *)Warp3DBase,-240,(APTR)LibW3D_ReadZSpan);
	PtrW3D_WriteZPixel 	=SetFunction((struct Library *)Warp3DBase,-348,(APTR)LibW3D_WriteZPixel);
	PtrW3D_WriteZSpan		=SetFunction((struct Library *)Warp3DBase,-354,(APTR)LibW3D_WriteZSpan);

	PtrW3D_DrawArray  	=SetFunction((struct Library *)Warp3DBase,-516,(APTR)LibW3D_DrawArray);
	PtrW3D_DrawElements	=SetFunction((struct Library *)Warp3DBase,-522,(APTR)LibW3D_DrawElements);
#endif

	VAR(PtrW3D_DrawArray);
	VAR(PtrW3D_DrawElements);
	VAR(PtrW3D_DrawLine);
	VAR(PtrW3D_DrawLineStrip);
	VAR(PtrW3D_DrawLineLoop);
	VAR(PtrW3D_DrawPoint);
	VAR(PtrW3D_ReadZSpan);
	VAR(PtrW3D_WriteZSpan);
	VAR(PtrW3D_ReadZPixel);
	VAR(PtrW3D_WriteZPixel);

#ifdef __amigaos4__
	OSAlert("Warp3D-ppc patched (Ctrl C=exit)");
	Wait(SIGBREAKF_CTRL_C);

	PtrW3D_DrawPoint		=SetMethod(IWarp3D, offsetof(struct Warp3DIFace, W3D_DrawPoint)	 ,(APTR)PtrW3D_DrawPoint); 
	PtrW3D_DrawLine		=SetMethod(IWarp3D, offsetof(struct Warp3DIFace, W3D_DrawLine)	 ,(APTR)PtrW3D_DrawLine); 
	PtrW3D_DrawLineStrip	=SetMethod(IWarp3D, offsetof(struct Warp3DIFace, W3D_DrawLineStrip),(APTR)PtrW3D_DrawLineStrip); 
	PtrW3D_DrawLineLoop	=SetMethod(IWarp3D, offsetof(struct Warp3DIFace, W3D_DrawLineLoop) ,(APTR)PtrW3D_DrawLineLoop); 

	PtrW3D_ReadZPixel		=SetMethod(IWarp3D, offsetof(struct Warp3DIFace, W3D_ReadZPixel)	 ,(APTR)PtrW3D_ReadZPixel); 
	PtrW3D_ReadZSpan		=SetMethod(IWarp3D, offsetof(struct Warp3DIFace, W3D_ReadZSpan)	 ,(APTR)PtrW3D_ReadZSpan); 
	PtrW3D_WriteZPixel	=SetMethod(IWarp3D, offsetof(struct Warp3DIFace, W3D_WriteZPixel)	 ,(APTR)PtrW3D_WriteZPixel); 
	PtrW3D_WriteZSpan		=SetMethod(IWarp3D, offsetof(struct Warp3DIFace, W3D_WriteZSpan)	 ,(APTR)PtrW3D_WriteZSpan); 

	PtrW3D_DrawArray		=SetMethod(IWarp3D, offsetof(struct Warp3DIFace, W3D_DrawArray)	 ,(APTR)PtrW3D_DrawArray); 
	PtrW3D_DrawElements	=SetMethod(IWarp3D, offsetof(struct Warp3DIFace, W3D_DrawElements) ,(APTR)PtrW3D_DrawElements); 
#else
	OSAlert("Warp3D-68k patched (Ctrl C=exit)");
	Wait(SIGBREAKF_CTRL_C);

	PtrW3D_DrawPoint		=SetFunction((struct Library *)Warp3DBase,-156,(APTR)PtrW3D_DrawPoint);
	PtrW3D_DrawLine		=SetFunction((struct Library *)Warp3DBase,-150,(APTR)PtrW3D_DrawLine);
	PtrW3D_DrawLineStrip	=SetFunction((struct Library *)Warp3DBase,-390,(APTR)PtrW3D_DrawLineStrip);
	PtrW3D_DrawLineLoop	=SetFunction((struct Library *)Warp3DBase,-396,(APTR)PtrW3D_DrawLineLoop);

	PtrW3D_ReadZPixel		=SetFunction((struct Library *)Warp3DBase,-234,(APTR)PtrW3D_ReadZPixel);
	PtrW3D_ReadZSpan		=SetFunction((struct Library *)Warp3DBase,-240,(APTR)PtrW3D_ReadZSpan);
	PtrW3D_WriteZPixel 	=SetFunction((struct Library *)Warp3DBase,-348,(APTR)PtrW3D_WriteZPixel);
	PtrW3D_WriteZSpan		=SetFunction((struct Library *)Warp3DBase,-354,(APTR)PtrW3D_WriteZSpan);

	PtrW3D_DrawArray  	=SetFunction((struct Library *)Warp3DBase,-516,(APTR)PtrW3D_DrawArray);
	PtrW3D_DrawElements	=SetFunction((struct Library *)Warp3DBase,-522,(APTR)PtrW3D_DrawElements);
#endif

	VAR(PtrW3D_DrawArray);
	VAR(PtrW3D_DrawElements);
	VAR(PtrW3D_DrawLine);
	VAR(PtrW3D_DrawLineStrip);
	VAR(PtrW3D_DrawLineLoop);
	VAR(PtrW3D_DrawPoint);
	VAR(PtrW3D_ReadZSpan);
	VAR(PtrW3D_WriteZSpan);
	VAR(PtrW3D_ReadZPixel);
	VAR(PtrW3D_WriteZPixel);

	OSAlert("Warp3D restaured");

	CloseLibrary(IntuitionBase);
	CloseLibrary(AslBase);
	CloseLibrary(Warp3DBase);
	exit(0);
}
/*==========================================================================*/


